<?php
// Recibir el parámetro de código de empresa desde la solicitud POST
$codigoempresa = $_POST['codigoempresa'];

// Configuración de la base de datos MySQL
$host_mysql = "localhost";
$user_mysql = "enviofac_usergps";
$pass_mysql = "GtZSfBS8Mqrt";
$db_mysql = "enviofac_ubicaciones";

// Conexión a la base de datos MySQL
$conn_mysql = new mysqli($host_mysql, $user_mysql, $pass_mysql, $db_mysql);

if ($conn_mysql->connect_error) {
    // Error de conexión a MySQL
    http_response_code(500);
    echo json_encode(["status" => "error", "message" => "Error en la conexión a MySQL: " . $conn_mysql->connect_error]);
    exit();
}

// Consulta a la tabla 'control' en MySQL usando el código de empresa
$sql_control = "SELECT ip, base, usuario, clave FROM control WHERE codcia = ?";
$stmt = $conn_mysql->prepare($sql_control);
$stmt->bind_param('s', $codigoempresa);
$stmt->execute();
$result = $stmt->get_result();

if ($result->num_rows > 0) {
    $row = $result->fetch_assoc();
    
    // Credenciales para la conexión al servidor SQL Server
    $server_sqlserver = $row['ip'];
    $database_sqlserver = $row['base'];
    $username_sqlserver = $row['usuario'];
    $password_sqlserver = $row['clave'];

    // Conexión al servidor SQL Server usando PDO
    $dsn = "sqlsrv:Server=$server_sqlserver;Database=$database_sqlserver";
    try {
        $conn_sqlserver = new PDO($dsn, $username_sqlserver, $password_sqlserver);
        $conn_sqlserver->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

        // Si la conexión es exitosa, devolvemos un código 200 con un mensaje de éxito
        http_response_code(200);
        echo json_encode(["status" => "OK", "message" => "Conexión a SQL Server exitosa."]);
    } catch (PDOException $e) {
        // Si hay un error al conectar a SQL Server, devolvemos un error
        http_response_code(500);
        echo json_encode(["status" => "error", "message" => "Error en la conexión a SQL Server: " . $e->getMessage()]);
    }
} else {
    // Si no se encuentran credenciales para la empresa
    http_response_code(404);
    echo json_encode(["status" => "error", "message" => "No se encontraron credenciales para la empresa proporcionada."]);
}

// Cerrar conexiones
$stmt->close();
$conn_mysql->close();
?>
