<?php
session_start();
if (!isset($_SESSION['codigo_empresa'])) {
    header("Location: inicio.php");
    exit();
}

$servername = "localhost";


$username = "enviofac_usergps";
$password = "GtZSfBS8Mqrt";
$dbname = "enviofac_ubicaciones";

// Crear la conexión a MySQL
$conn = new mysqli($servername, $username, $password, $dbname);

// Verificar la conexión
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$empresa = $_SESSION['codigo_empresa'];
$sql_vendedores = "SELECT * FROM vendedor WHERE empresa = '$empresa'";
$result_vendedores = $conn->query($sql_vendedores);

$vendedor_id = isset($_GET['vendedor_id']) ? $_GET['vendedor_id'] : "";

$conn->close();
?>
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Rastreo en Tiempo Real del Vendedor</title>
    <link rel="stylesheet" href="https://unpkg.com/leaflet/dist/leaflet.css" />
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">
    <style>
        #map {
            height: 600px;
            width: 100%;
        }
        body {
            background-color: #f8f9fa;
        }
        .navbar-nav .nav-link {
            color: white !important;
            padding: 10px 15px;
            border-radius: 10px;
        }       
        .navbar-nav .nav-link:hover {
            background-color: #007bff;
        }
        .navbar-nav .logout-btn {
            background-color: #dc3545;
            color: white !important;
            border-radius: 20px;
        }
        .navbar-nav .logout-btn:hover {
            background-color: #bd2130;
        }
        .navbar-collapse {
            transition: max-height 0.5s ease-in-out;
        }
        .logout-btn {
            width: 100%;
        }
        .arrow-button {
            position: relative;
            left: 50%;
            transform: translateX(-50%);
            margin-top: 10px;
            background: transparent;
            border: none;
            cursor: pointer;
            z-index: 1000;
            opacity: 0.8;
            transition: top 0.3s, opacity 0.3s;
        }
        .arrow-button.hidden {
            position: fixed;
            top: 60px;
            left: 50%;
            transform: translateX(-50%);
            opacity: 0.5;
        }
        .arrow-button:hover {
            opacity: 1;
        }
        .search-container {
            transition: max-height 0.5s ease-in-out;
            overflow: hidden;
        }
        .search-container {
            overflow: hidden;
            transition: height 0.5s ease;
            height: auto; 
        }
        .hidden {
            height: 0;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-primary">
        <div class="container-fluid">
            <a class="navbar-brand" href="menu.php">Menú Principal</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link" href="#">Ruta del Vendedor</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="map3.php">Pedidos del Vendedor</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="mapa.php">Vendedor en Tiempo Real</a>
                    </li>
                </ul>
                <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link logout-btn" href="cerrar.php">Cerrar Sesión</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>
    <div id="searchContainer" class="container mt-5 search-container">
        <form method="GET" action="mapa.php">
            <div class="mb-3">
                <label for="vendedor_id" class="form-label">Seleccionar Vendedor</label>
                <select id="vendedor_id" name="vendedor_id" class="form-select">
                    <?php while ($vendedor = $result_vendedores->fetch_assoc()): ?>
                        <option value="<?php echo $vendedor['codigo']; ?>" 
                            <?php echo $vendedor_id == $vendedor['codigo'] ? 'selected' : ''; ?>>
                            <?php echo $vendedor['nombre']; ?>
                        </option>
                    <?php endwhile; ?>
                </select>
            </div>
            <button type="submit" class="btn btn-primary">Filtrar</button>
        </form>
    </div>

    <button id="toggle-search" class="arrow-button">
        <i class="fas fa-chevron-up"></i>
    </button>
    <div id="map"></div>

    <script src="https://unpkg.com/leaflet/dist/leaflet.js"></script>
    <script>
        // Inicializar el mapa
        var map = L.map('map').setView([0, 0], 13);

        // Agregar la capa de mapa de OpenStreetMap
        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(map);

        var marker; // Marcador global para actualizarlo en tiempo real

        async function cargarUbicacionEnTiempoReal(vendedorId) {
            try {
                const response = await fetch(`obtener_ultima_ubicacion.php?vendedor_id=${vendedorId}`);
                const data = await response.json();

                if (data.error) {
                    console.error('Error del servidor:', data.error);
                    return;
                }

                if (data.latitud && data.longitud) {
                    var latitud = data.latitud;
                    var longitud = data.longitud;
                    var posicion = [latitud, longitud];

                    if (marker) {
                        marker.setLatLng(posicion);
                    } else {
                        marker = L.marker(posicion).addTo(map)
                            .bindPopup(`<b>Vendedor: ${data.codigovendedor}</b><br>Fecha: ${data.fecha}<br>Hora: ${data.hora}`).openPopup();
                    }
                } else {
                    console.error('No se encontraron datos de ubicación.');
                }
            } catch (error) {
                console.error('Error al cargar la ubicación en tiempo real:', error);
            }
        }

        document.addEventListener("DOMContentLoaded", function () {
            const toggleButton = document.getElementById("toggle-search");
            const searchContainer = document.getElementById("searchContainer");
            const vendedorId = document.getElementById('vendedor_id').value;

            cargarUbicacionEnTiempoReal(vendedorId);

            toggleButton.addEventListener("click", function () {
                searchContainer.classList.toggle("hidden");

                if (searchContainer.classList.contains("hidden")) {
                    toggleButton.classList.add("hidden");
                    toggleButton.innerHTML = '<i class="fas fa-chevron-down"></i>';
                } else {
                    toggleButton.classList.remove("hidden");
                    toggleButton.innerHTML = '<i class="fas fa-chevron-up"></i>';
                }
            });

            setInterval(() => {
                cargarUbicacionEnTiempoReal(vendedorId);
            }, 5000);
        });
    </script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.bundle.min.js"></script>
</body>
</html>
